#if !defined(AFX_LISTFILES_H__007B54EB_2B0B_422F_9E56_C00FD7701277__INCLUDED_)
#define AFX_LISTFILES_H__007B54EB_2B0B_422F_9E56_C00FD7701277__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// ListFiles.h : header file
//
#define MAX_TITLE_LEN 50

/////////////////////////////////////////////////////////////////////////////
// CListItem
class CListItem
{
public:
	CListItem();
	~CListItem();
	CListItem(const CListItem & video);

	void	operator=(const CListItem & item);
	BOOL	operator==(const CListItem & item);
	BOOL	operator!=(const CListItem & item);
	void	Copy(const CListItem & item);
	void	Zero();

	CString m_fileName;
	CString m_title;
	UINT	m_sizeKb;
};
/////////////////////////////////////////////////////////////////////////////
// CItemArray
class CItemArray : public CArray <CListItem, CListItem&> 
{
	static int CompareNameAscend(const void *, const void *);
	static int CompareTitlesAscend(const void *, const void *);
	static int CompareSizeAscend(const void *, const void *);

	static int CompareNameDescend(const void *, const void *);
	static int CompareTitlesDescend(const void *, const void *);
	static int CompareSizeDescend(const void *, const void *);

	public:
	void SortNames(BOOL ascend = TRUE);
	void SortTitles(BOOL ascend = TRUE);
	void SortSizes(BOOL ascend = TRUE);
};


/////////////////////////////////////////////////////////////////////////////
// CListFiles window

class CListFiles : public CListCtrl
{
// Construction
public:
	CListFiles();

// Attributes
public:

// Operations
public:
	BOOL CreateList(CWnd * parent, CRect client);
	void DestroyList();
	BOOL ListShowing();
	void Resize(CRect rect);
	void SetCurSelVideo();

private:
	BOOL LoadVideoFiles();
	void SetFilesList();
	void GetColWidths(int & col1, int & col2, int & col3);

	static int CALLBACK CompareFunc (LPARAM lParam1, LPARAM lParam2,
									 LPARAM lParamSort);
private:
	CItemArray m_itemAr;
	int		m_lastColSort;
	BOOL	m_lastColAscend;
	CFont	m_listFont;


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CListFiles)
	//}}AFX_VIRTUAL
	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);

// Implementation
public:
	virtual ~CListFiles();

	// Generated message map functions
protected:
	//{{AFX_MSG(CListFiles)
	afx_msg void OnGetdispinfo(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnColumnclick(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_LISTFILES_H__007B54EB_2B0B_422F_9E56_C00FD7701277__INCLUDED_)



