
/*	Copyright (C) G. Jespersen
	See Licence.txt.*/

// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Khan.h"
#include "Doc.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_ACTIVATE()
	//}}AFX_MSG_MAP

	ON_MESSAGE (WM_USER_UPDATE_FINISHED, OnUpdateFinished)
	ON_MESSAGE (WM_USER_UPDATE_ABORTED, OnUpdateAborted)
	ON_MESSAGE (WM_USER_DOWNLOAD_FINISHED, OnDownloadFinished)
	ON_MESSAGE (WM_USER_DOWNLOAD_ABORTED, OnDownloadAborted)
	ON_MESSAGE (WM_USER_APP_UPDATE_FINISHED, OnAppUpdateFinished)
	ON_MESSAGE (WM_USER_APP_UPDATE_ABORTED, OnAppUpdateAborted)


END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here

	m_minimized = FALSE;
	m_prePaused = FALSE;
	m_activeTime = 0;
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
/*	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}*/

/*	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}*/

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
/*	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);*/

	EnableDocking(CBRS_ALIGN_ANY);
	// Controls Dialog Bar
	//
	// Create
	if (!m_controlsBar.Create(this,  IDD_CONTROLS_BAR, 
									 WS_TABSTOP			| 
									 CBRS_ALIGN_TOP		|
									 CBRS_GRIPPER		| 
									 CBRS_TOOLTIPS		| 
									 CBRS_FLYBY			|
									 CBRS_SIZE_DYNAMIC,
									 IDD_CONTROLS_BAR)	)
	{
		TRACE0("Failed to create m_controlsBar\n");
		return -1;      // fail to create
	}
	m_controlsBar.EnableDocking(CBRS_ALIGN_TOP | CBRS_ALIGN_BOTTOM);
	DockControlBar(&m_controlsBar);
	// Show DrawingBar.
 	ShowControlBar(&m_controlsBar, TRUE, FALSE);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	// Eliminate Frame title - set in View::OnUpdate
	cs.style &= ~FWS_ADDTOTITLE;


	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

// Send Command Messages to inactive views. Enables Zoom menu items.
// See CDoc::RouteCmdToAllViews().
// From Wanderer - Prosise - ch. 11.
BOOL CMainFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo) 
{
    // Route to standard command targets first, which includes the active view
    if (CFrameWnd::OnCmdMsg (nID, nCode, pExtra, pHandlerInfo))
        return TRUE;
	
    // If message was not handled, try the inactive views.
	CDoc * pDoc = (CDoc *) GetActiveDocument();

	// If a document.
    if (pDoc != NULL) 
		return pDoc->RouteCmdToAllViews(GetActiveView(), nID, nCode, pExtra, pHandlerInfo);

    return FALSE;
}

// Message from CDoc worker thread.
//
// Khan Update
LRESULT CMainFrame::OnUpdateFinished(WPARAM wParam, LPARAM lParam)	// WM_USER_UPDATE_FINISHED
{
	CDoc * pDoc = ((CApp*)AfxGetApp())->m_pDoc;
	if(!pDoc)
		return 0;
	pDoc->UpdateFinished();
	return 0;
}
LRESULT CMainFrame::OnUpdateAborted(WPARAM wParam, LPARAM lParam)	// WM_USER_UPDATE_ABORTED
{
	CDoc * pDoc = ((CApp*)AfxGetApp())->m_pDoc;
	if(!pDoc)
		return 0;
	pDoc->UpdateAborted();
	return 0;
}

// Video Download
LRESULT CMainFrame::OnDownloadFinished(WPARAM wParam, LPARAM lParam)	// WM_USER_DOWNLOAD_FINISHED
{
	CDoc * pDoc = ((CApp*)AfxGetApp())->m_pDoc;
	if(!pDoc)
		return 0;
	pDoc->DownloadFinished();

	return 0;
}
LRESULT CMainFrame::OnDownloadAborted(WPARAM wParam, LPARAM lParam)	// WM_USER_DOWNLOAD_ABORTED
{
	CDoc * pDoc = ((CApp*)AfxGetApp())->m_pDoc;
	if(!pDoc)
		return 0;
	pDoc->DownloadAborted();
	return 0;
}

// Application Update
LRESULT CMainFrame::OnAppUpdateFinished(WPARAM wParam, LPARAM lParam)// WM_USER_APP_UPDATE_FINISHED
{
	CDoc * pDoc = ((CApp*)AfxGetApp())->m_pDoc;
	if(!pDoc)
		return 0;
	pDoc->AppUpdateFinished();

	return 0;
}
LRESULT CMainFrame::OnAppUpdateAborted(WPARAM wParam, LPARAM lParam)// WM_USER_APP_UPDATE_ABORTED
{
	CDoc * pDoc = ((CApp*)AfxGetApp())->m_pDoc;
	if(!pDoc)
		return 0;
	pDoc->AppUpdateAborted();
	return 0;
}
/*
// Stream Test
// 5/20/15
LRESULT CMainFrame::OnStreamTestFinished(WPARAM wParam, LPARAM lParam)// WM_USER_STREAM_TEST_FINISHED
{
	CDoc * pDoc = ((CApp*)AfxGetApp())->m_pDoc;
	if(!pDoc)
		return 0;
	pDoc->StreamTestFinished();

	return 0;
}
LRESULT CMainFrame::OnStreamTestAborted(WPARAM wParam, LPARAM lParam)// WM_USER_STREAM_TEST_ABORTED
{
	CDoc * pDoc = ((CApp*)AfxGetApp())->m_pDoc;
	if(!pDoc)
		return 0;
	pDoc->StreamTestAborted();
	return 0;
}
*/

// Pause / depause video if minimized / maximized / activated / deactivated.
// OnActivate basically sucks. We do not know which application is being
// activated as pWndOther is always 0.
void CMainFrame::OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized) 
{
	CFrameWnd::OnActivate(nState, pWndOther, bMinimized);

	// The window is being deactivated
	if(nState == WA_INACTIVE)
	{
	//	CView * pView = GetActiveView();
	//	if(pView)
	//		pView->PostMessage(WM_USER_SET_ACTIVATE, 0, 1);
		HWND hwndView = ((CApp*)AfxGetApp())->m_hwndView;
		if(hwndView)
			::PostMessage(hwndView, WM_USER_SET_ACTIVATE, 0, 1);
	}
	// The window is being activated - not used.
	else if(nState == WA_ACTIVE || nState == WA_CLICKACTIVE)
	{
	//	CView * pView = GetActiveView();
	//	if(pView)
	//		pView->PostMessage(WM_USER_SET_ACTIVATE, 1, 0);
		HWND hwndView = ((CApp*)AfxGetApp())->m_hwndView;
		if(hwndView)
			::PostMessage(hwndView, WM_USER_SET_ACTIVATE, 1, 0);
	}
}
